/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.kintai.action;

import java.util.Date;

import jp.mosp.common.CommonConst;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.utils.DateUtil;
import jp.mosp.common.utils.VariousUtil;
import jp.mosp.kintai.common.action.MosPWorkflowAction;
import jp.mosp.kintai.common.part.KintaiApprovalPart;
import jp.mosp.kintai.common.part.KintaiCommonPart;
import jp.mosp.kintai.kintai.dto.MSyukkinboDto;
import jp.mosp.kintai.kintai.vo.AttendanceCheckCardVo;

/**
 * @author yoshida
 *
 */
public class AttendanceCheckCardAction extends MosPWorkflowAction {
	
	// コマンド
	/**
	 * 
	 */
	public static final String	CMD_CHECK_CARD_SELECT		= "K1121";
	private static final String	CMD_CHECK_CARD_REGIST		= "K1122";
	private static final String	CMD_CHECK_CARD_DELETE		= "K1123";
	private static final String	CMD_CHECK_CARD_DRAFT		= "K1124";
	private static final String	CMD_CHECK_CARD_CALCULATE	= "K1126";
	

	/**
	 * コンストラクタ
	 */
	public AttendanceCheckCardAction() {
		super();
	}
	
	public void action() throws Exception {
		// VOの取得
		prepareVo();
		// 初期処理
		init();
		// コマンド毎の処理
		if (cmd.equals(CMD_CHECK_CARD_SELECT)) {
			// 選択
			select();
		} else if (cmd.equals(CMD_CHECK_CARD_REGIST)) {
			// 登録
			regist(false);
		} else if (cmd.equals(CMD_CHECK_CARD_DELETE)) {
			// 削除
			delete();
		} else if (CMD_CHECK_CARD_DRAFT.equals(cmd)) {
			// 下書き
			regist(true);
		} else if (CMD_CHECK_CARD_CALCULATE.equals(cmd)) {
			// 集計
			runCalc();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new AttendanceCheckCardVo();
	}
	
	@Override
	protected void init() throws Exception {
		AttendanceCheckCardVo vo = (AttendanceCheckCardVo)getVo();
		// ユーザー情報取得
		getInfo(user.getUserId());
		// 手当一覧
		vo.setAryAllowance(getMosPCodeArray(CommonConst.TID_ALLOWANCE_NAME));
		// 勤務形態プルダウン
		vo.aryPltWorkType = part().worktype().getWorkTypeInfoArrayWithHoliday();
		// 休出区分プルダウン
		vo.aryPltWorkOnHoliday = getMosPCodeArray(CommonConst.TID_WORK_ON_HOLIDAY_TYPE);
		// 出勤時半休区分プルダウン
		vo.aryPltStartHalfHoliday = getHalfHolidayArray();
		// 遅刻理由プルダウン
		vo.aryPltLateReason = getReasonCodeArray(CommonConst.TID_LATE_REASON);
		// 遅刻証明書プルダウン
		vo.aryPltLateCertificate = getMosPCodeArray(CommonConst.TID_LATE_CERTIFICATE);
		// 退勤時半休区分プルダウン
		vo.aryPltQuitHalfHoliday = getHalfHolidayArray();
		// 早退理由プルダウン
		vo.aryPltLeaveEarlyReason = getReasonCodeArray(CommonConst.TID_LEAVE_EARLY_REASON);
		// 早退証明書プルダウン
		vo.aryPltLeaveEarlyCertificate = getMosPCodeArray(CommonConst.TID_LEAVE_EARLY_CERTIFICATE);
		// 勤怠管理コマンド
		setSubTitleMenu();
	}
	
	@Override
	protected void select() throws Exception {
		AttendanceCheckCardVo vo = (AttendanceCheckCardVo)getVo();
		// 表示の準備
		setAttendanceInfo();
		// 勤怠検索
		MSyukkinboDto dto = kintai().getSyukkinboInfo(vo.getHidKCode(), vo.getHidDate(), false);
		chkExist(dto);
		// VOに情報を設定
		vo.setFields(dto);
		// 下書き判断
		vo.setDraft(true);
		if (!KintaiApprovalPart.isDraft(dto)) {
			vo.setDraft(false);
		}
		// 表示モードのセット
		setMode(dto);
		// ラベル表示のセット
		vo.setLabelInfo(dto);
		// 時間外警告対応
		setOverTimeCaution(vo.getHidKCode(), DateUtil.convStringDateToDate(vo.getHidDate()));
	}
	
	/**
	 * 勤怠登録
	 * @param isDraft	下書きフラグ
	 * @throws Exception	例外処理が発生した場合
	 */
	private void regist(boolean isDraft) throws Exception {
		AttendanceCheckCardVo vo = (AttendanceCheckCardVo)getVo();
		vo.setParams(request);
		// パラメータの妥当性確認
		vo.validate();
		MSyukkinboDto dto = kintai().getSyukkinboInfo(vo.getHidKCode(), vo.getHidDate(), true);
		if (VariousUtil.isNull(dto)) {
			// 勤怠一覧へ戻る(勤怠データが無い場合)
			String errMessage = getMessage(CommonConst.MSG_NO_ATTENDANCE, "");
			addErrMessage(errMessage);
			setNextCmd(AttendanceListAction.CMD_ATTENDANCE_LIST_RE_SEARCH);
			throw new MospException(CommonConst.EX_NO_ATTENDANCE, errMessage);
		} else {
			// 承認済みの場合はメッセージ表示、登録不可
			if (KintaiApprovalPart.isApproved(dto)) {
				// メッセージ設定
				setMessage(getMessage(CommonConst.MSG_ALREADY_APPROVED, getMessageDate(dto)));
			} else {
				// UPDATE
				// 排他確認
				chkExclusive(dto, kintai().getSyukkinboInfo(dto.getKCode(), dto.getHizuke(), true));
				// VOの値をセット
				vo.setDtoFields(dto);
				// 下書き判断
				if (isDraft) {
					dto.setSnRiyuu(CommonConst.CODE_DRAFT);
				}
				boolean startFlag = true;
				boolean quitFlag = true;
				Date targetDate = DateUtil.convStringDateToDate(dto.getHizuke());
				// 午前半休の場合、残日数をチェックする。
				if (KintaiCommonPart.isStartHalfHoliday(dto)) {
					if (!part().holidayRequest().isApprovedPaidHolidayRequestStartHalf(dto)) {
						startFlag = checkRemainPaidHoliday(dto.getKCode(), targetDate, CommonConst.NUM_HALF_DAY, 0);
					}
				}
				// 時間外代休(午前半日)の場合、残日数をチェックする。
				if (part().mospcode().useSubstituteHolidayFunction() && KintaiCommonPart.isOverTimeSubHolidayStart(dto)) {
					if (!part().holidayRequest().isApprovedSubstituteHolidayRequestStartHalf(dto)) {
						startFlag = checkRemainSubstitute(dto.getKCode(), targetDate, CommonConst.NUM_HALF_DAY);
					}
				}
				// 午後半休の場合、残日数をチェックする。
				if (KintaiCommonPart.isQuitHalfHoliday(dto)) {
					if (!part().holidayRequest().isApprovedPaidHolidayRequestQuitHalf(dto)) {
						quitFlag = checkRemainPaidHoliday(dto.getKCode(), targetDate, CommonConst.NUM_HALF_DAY, 0);
					}
				}
				// 時間外代休(午後半日)の場合、残日数をチェックする。
				if (part().mospcode().useSubstituteHolidayFunction() && KintaiCommonPart.isOverTimeSubHolidayQuit(dto)) {
					if (!part().holidayRequest().isApprovedSubstituteHolidayRequestQuitHalf(dto)) {
						quitFlag = checkRemainSubstitute(dto.getKCode(), targetDate, CommonConst.NUM_HALF_DAY);
					}
				}
				if (startFlag && quitFlag) {
					// 午前半休、午後半休、時間単位の年休の承認がある場合、反映
					margeHolidayRequest(dto);
					// 自動計算
					runAutoCheckCalc(dto);
					// 更新（全項目）
					syukkinboDao().update(dto);
					// メッセージ設定
					setMessage(getMessage(MospConst.MSG_UPDATE, ""));
				}
			}
		}
		// コミット
		commit();
		// 勤怠一覧へ遷移
		setNextCmd(AttendanceListAction.CMD_ATTENDANCE_LIST_RE_SEARCH);
	}
	
	/**
	 * 集計
	 * @throws Exception	例外処理が発生した場合
	 */
	private void runCalc() throws Exception {
		AttendanceCheckCardVo vo = (AttendanceCheckCardVo)getVo();
		vo.setParams(request);
		// パラメータの妥当性確認
		vo.validate();
		MSyukkinboDto dto = kintai().getSyukkinboInfo(vo.getHidKCode(), vo.getHidDate());
		vo.setDtoFields(dto);
		if (KintaiCommonPart.isAvailableWorkType(dto)) {
			// 休暇申請とマージ
			margeHolidayRequest(dto);
			kintai().runCalculatedInfo(dto);
			vo.setFields(dto);
		}
		// 時間外警告対応
		setOverTimeCaution(vo.getHidKCode(), DateUtil.convStringDateToDate(vo.getHidDate()), dto.getZaJikan());
	}
	
	/**
	 * 自動計算メソッド
	 * @param dto		対象DTO
	 * @throws Exception	例外処理が発生した場合
	 */
	private void runAutoCheckCalc(MSyukkinboDto dto) throws Exception {
		// 勤怠情報設定
		setCalcParam();
		// 自動計算フラグ有り且つ週休以外のみ
		// 日次自動計算フラグ
		if (isDailyAutoCalc && KintaiCommonPart.isAvailableWorkType(dto)) {
			// 勤怠項目計算 
			kintai().runCalculatedInfo(dto);
		}
	}
	
}
